Subject: Re: [PATCH] powerpc/book3e-64: use a separate TLB handler when linear map is bolted

From: Benjamin Herrenschmidt <[email-masked]>
Date: Thu, 23 Jun 2011 08:05:33 +1000

On Wed, 2011-06-22 at 16:24 -0500, Scott Wood wrote:
> 
> This saved another 1% or so.  I don't think TLB_SCRATCH needs to be saved
> by crit/debug/mcheck -- they shouldn't be taking TLB misses, at least
> in the bolted case.  

The code they call will (think accessing the UART)

> Even non-bolted, it doesn't look like there are enough
> extlb levels to deal with a linear TLB miss inside a crit/debug/mcheck
> inside a linear TLB miss inside a virtual page table miss inside a normal
> TLB miss.

My plan for crit/debug/mcheck (which I haven't implemented yet) was to
save the whole TLB save area onto the kernel stack and restore it.
 
> Currently, we could just as well take that crit/debug/mcheck after
> storing to TLB_SCRATCH but before saving it to extlb, and have the same
> problem.

Right. My point was more that TLB_SCRATCH itself shall be saved
somewhere by the crit/debug/mcheck handler along with the copy of the
TLB save area.

Cheers,
Ben.